package org.apache.lucene.index;

import java.io.IOException;
import java.util.Map;

abstract class DocFieldConsumer {

    /** Called when DocumentsWriter decides to create a new
   *  segment */
    abstract void flush(Map<FieldInfo, DocFieldConsumerPerField> fieldsToFlush, SegmentWriteState state) throws IOException;

    /** Called when an aborting exception is hit */
    abstract void abort();

    /** Add a new thread */
    /** Called when DocumentsWriter is using too much RAM.
   *  The consumer should free RAM, if possible, returning
   *  true if any RAM was in fact freed. */
    abstract boolean freeRAM();

    abstract void startDocument() throws IOException;

    abstract DocFieldConsumerPerField addField(FieldInfo fi);

    abstract void finishDocument() throws IOException;
}
